const protobuf = require("protobufjs");
const fs = require("fs").promises;

module.exports = class ProtoLoader {
  constructor(n) {
    this.n = n;

    this.c = n.config;
    this.log = n.log;
  }

  async load() {
    this.log.info(`Loading protos..`);
    await this.clean();
    await this.createRequestTypeFile();
    await this.createMainFile();
    await this.loadMain();
  }

  async clean() {
    try {
      await fs.unlink(`./protos/_RequestType_.proto`);
      await fs.unlink(`./protos/_Main_.proto`);
    } catch(e) {
      return;
    }
  }

  async createRequestTypeFile(cb) {
    var content = `syntax = "proto3";\n\n`;
    content += `// This is a dynamic file generated by noctane ProtoLoader, do not edit\n\n`;
    content += `enum RequestType {\n`;

    var index = 1;
    this.n.endpoints.forEach((endpoint) => {
      content += `  ${endpoint.id.toUpperCase()} = ${index};\n`
      index++;
    })

    content += `}`;

    await fs.writeFile(`../protos/_RequestType_.proto`, content, "utf-8");
  }

  async createMainFile(cb) {
    var content = `syntax = "proto3";\n\n`;
    content += `// This is a dynamic file generated by ndb ProtoLoader, do not edit\n\n`;
    //content += `import "DataRoot.proto";\n`;
    content += `import "Request.proto";\n`;
    content += `import "_RequestType_.proto";\n`;

    this.n.endpoints.forEach((endpoint) => {
      content += `import "${endpoint.id}.proto";\n`;
      content += `import "${endpoint.id}Response.proto";\n`;
    })

    await fs.writeFile(`../protos/_Main_.proto`, content, "utf-8");
  }

  async loadMain(cb) {
    try {
      this.n.pbRoot = await protobuf.load("../protos/_Main_.proto");
      this.log.info(`Protocol Buffer file tree successfully loaded`);
    } catch(e) {
      console.error(e);
      throw `An error occured when loading _Main_.proto`;
    }
  }
}
